// ProgramOne.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ProgramOne.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

void swap(int & oldValue, int & newValue);

void bubbleSort(int array[], int size);
// Precondition: 	provide array[] an array of integers in any order
//                  size the number of integers in the array
// Postcondition: 	returns array[] with integers sorted from left
//                	to right in ascending order using bubble sort
//                	algorithm

void quickSort(int array[], int size);
// Precondition: 	provide array[] an array of integers in any order
//                  size the number of integers in the array
// Postcondition: 	returns array[] with integers sorted from left
//                	to right in ascending order using quicksort
//                	algorithm

void displayArray(const int array[], int size);
// Precondition: 	provide array[] an array of integers in any order
//                  size the number of integers in the array
// Postcondition: 	outputs contents of array to standard out

void populateArray(int array[], int size);
// Precondition: 	provide array[] an array of integers
//                  size the number of integers in the array
// Postcondition: 	array[] is populated with random integers between 0 and 100000

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		int score[100000] = {99, 95, 79, 89, 77};
		int size=100000;
		
		cout << "Populating array..." << endl;
		populateArray(score,size);
		
		cout << "Sorting array..." << endl;

		bubbleSort(score,size);
		
		//quickSort(score,size);
		
		// displayArray(score,size);
		cout << "Press ENTER to terminate." << endl;

		char ch;
		cin.get(ch);

	}

	return nRetCode;
}

void bubbleSort(int array[], int size) 
{
	// array location of last value exchanged
	// initialized to rightmost position in array
	int lastExchanged =size - 1;
	
	while (lastExchanged > 0)
	{
		// All values to right of sorted_pos are are sorted in the array. 
		// As the algorithm executes this variable gets smaller and smaller 
		// approaching zero when it reaches the left side of the array.
		int sortedPos = lastExchanged;
		lastExchanged=0;
		
		// Starting at the beginning of the array.  Bubble up the largest
		// unsorted value in the array.  To do this, move the largest value from 
		// left to right by looking at array value pairs.  Swap pair values if
		// if the left is greater than right value.  Stop when you've reached the
		// sorted values in the array.

		for (int bubblePos=0; bubblePos<sortedPos; bubblePos++)
		{
			// swap pair values if left greater than right
			if (array[bubblePos]>array[bubblePos+1])
			{
			// swap array[bubble_pos] and array[bubble_pos+1]
			int temp = array[bubblePos];
			array[bubblePos] = array[bubblePos+1];
			array[bubblePos+1]=temp;
			//swap(array[bubblePos], array[bubblePos+1]);
		
			// When exiting the for loop all values from position lastExchanged
			// to size - 1 will be sorted.
			lastExchanged = bubblePos;
			}
		}
	}
}

void displayArray(const int array[], int size)
{
	for (int i=0; i<size; i++)
	{
		cout << array[i] << " ";
	}
	cout << endl;
	
}

void populateArray(int array[], int size)
{
	srand(time(0));
	for (int i=0; i<size; i++)
	{
		array[i]= rand() % 100000;
	}

}

void swap(int & oldValue, int & newValue)
{
	int temp;

	temp = oldValue;
	oldValue = newValue;
	newValue = temp;
}


int compare( const void *arg1, const void *arg2 );

void quickSort(int array[], int size)
{
   // Sort array using Microsoft's built in quicksort algorithm
   qsort( (void *) array, (size_t) size, sizeof(int *), compare );

}

int compare( const void *arg1, const void *arg2 )
{
	// Comparator
   return  ((* ( int * ) arg1) - (* (int *) arg2));
}

